// Copyright IBM Corp. 2015. All Rights Reserved.
// Node module: strong-agent
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

'use strict';

var path = require('path');

module.exports.detectModule = detectModule;
function detectModule(modulename, hasRun) {
  var location;

  try {
    location = require.resolve(modulename);
  } catch (err) {
  }

  if (location) {
    location = path.dirname(location);
    var version = require(path.resolve(location, 'package.json')).version;
    return version;
  } else if (!hasRun) {
    return detectModule(path.resolve(process.cwd(), 'node_modules', modulename),
                        true);
  }
  return null;
}
