// Copyright IBM Corp. 2015. All Rights Reserved.
// Node module: strong-agent
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

'use strict';

// FIXME(bnoordhuis) Unclear if require('../agent') is for side effects.
var agent = require('../agent');
var proxy = require('../proxy');
var counts = require('../counts');

module.exports = function(strongmq) {
  proxy.after(strongmq, 'create', function(obj, args, connection) {
    proxy.after(connection, ['createPushQueue', 'createPubQueue'],
                function(obj, args, queue) {
      proxy.after(queue, 'publish', function(obj, args, queue) {
        counts.sample('strongmq_out');
      });
    });
    proxy.after(connection, ['createPullQueue', 'createSubQueue'],
                function(obj, args, queue) {
      queue.on('message', function() { counts.sample('strongmq_in'); });
    });
  });

  return strongmq;
};
