// Copyright IBM Corp. 2015. All Rights Reserved.
// Node module: strong-agent
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

'use strict';

var oracleBase = require('./oracledb').oracleBase;
var proxy = require('../proxy');

function instrument(oracle) {
  return oracleBase(oracle, 'connectSync', 'connect', 'StrongOracle');
}

module.exports = function oracle(exports) {
  if (typeof exports !== 'function') {
    return instrument(exports);  // Pre-1.2 strong-oracle.
  }

  return proxy.wrap(exports, function(recv, args) {
    return instrument(exports.apply(recv, args));
  });
};
